<?php
/*
 * @component Calc Builder 
 * @copyright Copyright (C) October 2016. 
 * @license GPL 3.0 
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 * See <http://www.gnu.org/licenses/>. 
 * More info www.moonsoft.es 
 * gestion@moonsoft.es
 */
defined ( '_JEXEC' ) or die ( 'Direct Access to this location is not allowed.' );
class ModCalcBuilderHelper {
	protected function _buildQuerySelectFieldsOne($id, $class = 1, $type = null) {
		$query = "select *
        from #__calcbuilder_field  where idobj=" . $id . " and class=" . $class;
		if ($type != null)
			$query .= ' and type=' . $type;
		$query .= " order by `order` asc";
		return $query;
	}
	protected function _buildQuery($id) {
		$query = "select u.* from #__calcbuilder_utility u ";
		if ($id != null)
			$query .= 'where u.id=' . $id;
		return $query;
	}
	
	/*
	 * protected function _buildQueryEvents($id){ $query = "select * from #__calcbuilder_jsevents "; if ($id!=null) $query .= 'where idutility='.$id; return $query; }
	 */
	protected function _buildQuerySelectAllFieldsLayout($id) {
		$query = "select * from #__calcbuilder_field where idobj=" . $id;
		return $query;
	}
	/*
	 * protected function _buildQuerySelectLayoutPreference($id){ $query = "select name, val from #__calcbuilder_layout_preferences where idutility=".$id; return $query; }
	 */
	protected function _buildQuerySelectSection($id) {
		$query = "select s.*,group_concat(f.idfield) as fields from #__calcbuilder_section s left join #__calcbuilder_section_field f on s.id=f.idsection 
        			where s.idutility=" . $id . " group by s.id";
		return $query;
	}
	protected function _buildQuerySelectFieldSection($id) {
		$query = "select f.id,ifnull(sf.idsection,-1) as section 
					from #__calcbuilder_field f left join #__calcbuilder_section_field sf on f.id=sf.idfield
					where idobj=" . $id;
		return $query;
	}
	protected function _buildSelectMultivalues($id) {
		$query = "select * from #__calcbuilder_field_multivalue where idfield=" . $id . " order by ord";
		return $query;
	}
	protected function _buildSelectUserData($id, $iduser) {
		$query = "select data from #__calcbuilder_userdata where idutility=" . $id . " and iduser=" . $iduser;
		return $query;
	}
	public function getDataFields($id) {
		$db = JFactory::getDBO ();
		$query = $this->_buildQuerySelectFieldsOne ( $id, 1 );
		$db->setQuery ( $query );
		return $db->loadAssocList ();
	}
	public function getData($id) {
		$db = JFactory::getDBO ();
		$query = $this->_buildQuery ( $id );
		$db->setQuery ( $query );
		return $db->loadAssoc ();
	}
	
	/*
	 * public function getEvents($id) { $db = JFactory::getDBO(); $query = $this->_buildQueryEvents($id); $db->setQuery($query); return $db->loadObjectList(); }
	 */

    
	/*public function getDataLayoutPreference($id) {       
      $db = JFactory::getDBO();
      $query = $this->_buildQuerySelectLayoutPreference($id);
      $db->setQuery($query);
      return $db->loadObjectList('name');
    }*/
    
    public function getDataAllFieldsLayout($id) {
		$db = JFactory::getDBO ();
		$query = $this->_buildQuerySelectAllFieldsLayout ( $id );
		$db->setQuery ( $query );
		return $db->loadObjectList ( 'id' );
	}
	public function getDataSections($id) {
		$db = JFactory::getDBO ();
		$query = $this->_buildQuerySelectSection ( $id );
		$db->setQuery ( $query );
		return $db->loadObjectList ();
	}
	public function getDataFieldSection($id) {
		$db = JFactory::getDBO ();
		$query = $this->_buildQuerySelectFieldSection ( $id );
		$db->setQuery ( $query );
		return $db->loadObjectList ( 'id' );
	}
	public function getExecuteQuery($query) {
		$db = JFactory::getDBO ();
		$db->setQuery ( $query );
		return $db->loadRowList ();
	}
	protected function getMultivalues($id) {
		$db = JFactory::getDBO ();
		$query = $this->_buildSelectMultivalues ( $id );
		$db->setQuery ( $query );
		return $db->loadObjectList ();
	}
	protected function getMultivalueswrapper($field) {
		$multivalues = $this->getMultivalues ( $field->id );
		/*
		 * $ret =array(); foreach($multivalues as $fila){ $ret[]=$fila; } return $ret;
		 */
		return $multivalues;
	}
	protected function getUserdataWrapper($id, $iduser) {
		$db = JFactory::getDBO ();
		$query = $this->_buildSelectUserData ( $id, $iduser );
		$db->setQuery ( $query );
		return $db->loadResult ();
	}
	private function _isFieldInSection($idfield){
		$db = JFactory::getDBO ();
		$query = 'SELECT count(*) as insection FROM #__calcbuilder_section_field where idfield='.$idfield;
		$db->setQuery ($query);
		return $db->loadResult();		
	}
	public function getDataUserData($utility) {
		$ret = '';
		switch ($utility ['datasave']) {
			case '0' :
				$user = JFactory::getUser ();
				if ($user->guest)
					break;
				$ret = $this->getUserdataWrapper ( $utility ['id'], $user->id );
				break;
			case '1' :
				if (isset ( $_COOKIE ['cb_alldata_' . $utility ['id']] ))
					$ret = $_COOKIE ['cb_alldata_' . $utility ['id']];
				break;
		}
		return $ret;
	}
	public function getFieldHTML($data, $utility, $seccionfield, $field, $seed) {
		$pathImagenCalendar = JURI::base () . 'modules/mod_calcbuilder/assets/img/calendar.png';
		$retorno = "";
		$arr_suffix = $seccionfield ? '[]' : '';
		// $retorno.="<div class='cbu_fieldwrapper' id='fld_wrapper_".$field->id."'>";
		// $retorno.="<div class='cbu_fieldinput'>";
		$arrValidator = array ();
		// $arrValidator[]=' ';
		$class = '';
		if ($field->mandatory == 1)
			$arrValidator [] = 'required';
		if (strlen ( $field->limit0 ) || strlen ( $field->limit1 ) || $field->type == 0 || strlen ( $field->decimal )) {
			// $arrValidator[]='validate-elem'.$field->id;
			$arrValidator [] = 'elem' . $field->id;
		}
		$arrValidator [] = $field->css;
		if (count ( $arrValidator ) > 0)
			$class = 'class="' . implode ( ' ', $arrValidator );
		
		switch ($field->type) {
			case '0' :
				$class .= ' "';
				$retorno .= '<input type="number" fldname="' . $field->var . '" id="fld_' . $field->id . '" 
		        	name="fld_' . $field->id . $arr_suffix . '" ' . $class . ' value="' . $field->defaulttext . '" placeholder="' . $field->placeholder . '"/>';
				break;
			case '1' :
				$class .= ' input-append cbdate"';
				$randCal = rand ( 0, 9999999 );
				$retorno .= '<div ' . $class . '>
					    <input ' . $class . ' class="input-small" type="text" fldname="' . $field->var . '" 
					    	name="fld_' . $field->id . $arr_suffix . '" id="fld_' . $field->id . '_' . $randCal . '"  placeholder="' . $field->placeholder . '" value="' . $field->defaulttext . '" />
					    <!--<span class="add-on" id="fld_' . $field->id . '_img_' . $randCal . '"><i class="icon-calendar"></i></span>-->
					    </div>';
				if (!$seccionfield){
					$retorno .= '<script>
			            	CB(document).ready(function() {
			            		//Calendar.setup({inputField:\'fld_' . $field->id . '_' . $randCal . '\',ifFormat:\'' . $utility ["date_frontend_format"] . '\',button:\'fld_' . $field->id . '_img_' . $randCal . '\'});				            		
								setCalendarCB("fld_' . $field->id . '_' . $randCal . '", "fld_' . $field->id . '_img_' . $randCal . '");
						    }); </script>';
				}	    
				break;
			case '2' :
				$class .= ' "';
				$defval = $field->defaulttext;
				$multivalues = $this->getMultivalueswrapper ( $field );
				if (count ( $multivalues ) > 0 || ($field->sqltext != null && trim ( $field->sqltext ) != '')) {
					$retorno .= '<select fldname="' . $field->var . '" name="fld_' . $field->id . $arr_suffix . '" ' . $class . ' id="' . $field->var . '" mv_fld="' . $field->var . '"  mv_var="' . $field->var . '">';
					// TODO Poner value por defecto y descomentar la siguiente linea
					// $retorno.='<option value="">'.JText::_('LM_OPTION_BLANK').'</option>';
					if ($field->sqltext != null && trim ( $field->sqltext ) != '') {
						$more_fields = $this->getExecuteQuery ( $field->sqltext );
						foreach ( $more_fields as $sqlfields ) {
							$selectedtmp = '';
							if ($sqlfields [0] == $defval)
								$selectedtmp = ' selected="selected" ';
							$retorno .= '<option value="' . $sqlfields [0] . '" ' . $selectedtmp . ' mv_option="' . $sqlfields [0] . '">' . JText::_ ( $sqlfields [1] ) . '</option>';
						}
					}
					foreach ( $multivalues as $multiv ) {
						$selectedtmp = '';
						if ($multiv->value == $defval)
							$selectedtmp = ' selected="selected" ';
						$retorno .= '<option value="' . $multiv->id . '" ' . $selectedtmp . ' mv_option="' . $multiv->value . '">' . JText::_ ( $multiv->name ) . '</option>';
					}
					$retorno .= '</select>';
				}
				break;
			case '3' :
				// $retorno.='<input type="checkbox" fldname="'.$field->var.'" id="fld_'.$field->id.'" name="fld_'.$field->id.$arr_suffix.'" '.$class.' value="Y"/>';
				$class .= ' checkbox"';
				$retorno .= '<label ' . $class . '>
  					<input type="checkbox"  data-type="yesno" id="fld_' . $field->id . '" ' . $class . ' fldname="' . $field->var . '" name="fld_' . $field->id . $arr_suffix . '" value="Y" />
					</label>';
				break;
			case '4' :
				$class .= ' "';
				$retorno .= '<input type="text" fldname="' . $field->var . '" id="fld_' . $field->id . '" 
		        	name="fld_' . $field->id . $arr_suffix . '" ' . $class . ' value="' . $field->defaulttext . '"  
		        	mask="' . $field->mask . '" placeholder="' . $field->placeholder . '"/>';
				break;
			case '6' :
				$class .= ' mvlnkd"';
				$arrvar = explode ( '_', $field->var );
				array_pop ( $arrvar );
				$strvar = implode ( '_', $arrvar );
				$multivalues = $this->getMultivalueswrapper ( $field );
				$arrMVVals = array ();
				if (count ( $multivalues ) > 0 || ($field->sqltext != null && trim ( $field->sqltext ) != '')) {
					if ($field->sqltext != null && trim ( $field->sqltext ) != '') {
						$more_fields = $this->getExecuteQuery ( $field->sqltext );
						foreach ( $more_fields as $sqlfields ) {
							$arrMVVals [] = array (
									'value' => $sqlfields [0],
									'mv_option' => $sqlfields [0],
									'mv_val' => $sqlfields [1] 
							);
						}
					}
					foreach ( $multivalues as $multiv ) {
						$arrMVVals [] = array (
								'value' => $multiv->id,
								'mv_option' => $multiv->value,
								'mv_val' => JText::_ ( $multiv->name ) 
						);
					}
					$randMV = rand ( 0, 9999999 );
					// $retorno.='<script>CB(document).ready(function() {
					$retorno .= '<script>
		          var linkedTmp=new obj_LinkedList("' . $randMV . '");
		          var linkedvaltmp="";';
					foreach ( $arrMVVals as $mvval ) {
						$retorno .= 'linkedvaltmp=new obj_LinkedValue("' . $mvval ['value'] . '","' . $mvval ['mv_option'] . '","' . $mvval ['mv_val'] . '");';
						$retorno .= 'linkedTmp.add(linkedvaltmp);';
					}
					$retorno .= 'cb_linked' . $seed . '.add(linkedTmp);';
					// $retorno.='});</script>';
					$retorno .= '</script>';
					$retorno .= '<select fldname="' . $field->var . '" name="fld_' . $field->id . $arr_suffix . '" ' . $class . ' mv_ant="' . $strvar . '" mv_data="' . $randMV . '" id="fld_' . $field->id . '" mv_fld="' . $field->var . '"  mv_var="' . $field->var . '"></select>';
				}
				
				break;
			case '7' :
				$class .= ' checkbox"';
				$defval = explode ( ',', $field->defaulttext );
				$multivalues = $this->getMultivalueswrapper ( $field );
				if (count ( $multivalues ) > 0 || ($field->sqltext != null && trim ( $field->sqltext ) != '')) {
					if ($field->sqltext != null && trim ( $field->sqltext ) != '') {
						$more_fields = $this->getExecuteQuery ( $field->sqltext );
						$counter_multivalue = 0;
						foreach ( $more_fields as $sqlfields ) {
							$counter_multivalue ++;
							$retorno .= '<label ' . $class . ' >';
							$retorno .= '<input type="checkbox" data-type="cmultiple" fldname="' . $field->var . '"  mv_option="' . $sqlfields->mvkey . '" 
		          					id="fld_' . $field->id . '_' . $counter_multivalue . '" name="fld_' . $field->id . '[]" value="' . $sqlfields->mvkey . '"
		          					' . (in_array ( $sqlfields->mvkey, $defval ) ? ' checked="checked" ' : '') . '
		          					/>';
							$retorno .= JText::_ ( $sqlfields->mvvalue );
							$retorno .= '</label>';
						}
					}
					$i = 0;
					foreach ( $multivalues as $multiv ) {
						$retorno .= '<label ' . $class . ' >';
						$retorno .= '<input type="checkbox" data-type="cmultiple" fldname="' . $field->var . '"  mv_option="' . $multiv->value . '" id="fld_' . $field->id . '_' . $i . '"  
		          				name="fld_' . $field->id . '[]" value="' . $multiv->id . '"
		          				' . (in_array ( $multiv->value, $defval ) ? ' checked="checked" ' : '') . '
		          				/>';
						$retorno .= JText::_ ( $multiv->name );
						$retorno .= '</label>';
						$i ++;
					}
				}
				break;
			case '8' :
				$class .= ' "';
				$retorno .= '<textarea fldname="' . $field->var . '" id="fld_' . $field->id . '" 
		        	name="fld_' . $field->id . $arr_suffix . '" ' . $class . '  placeholder="' . $field->placeholder . '" >' . $field->defaulttext . '</textarea>';
				break;
			case '9' :
				$class .= ' "';
				$retorno .= '<script type="text/javascript">captchas' . $seed . '.sjcap("' . $field->id . '");</script>';
				break;
			case '10' :
				$class .= ' typeahead"';
				$multivalues = $this->getMultivalueswrapper ( $field );
				$arrAUVals = array ();
				if (count ( $multivalues ) > 0 || ($field->sqltext != null && trim ( $field->sqltext ) != '')) {
					if ($field->sqltext != null && trim ( $field->sqltext ) != '') {
						$more_fields = $this->getExecuteQuery ( $field->sqltext );
						foreach ( $more_fields as $sqlfields ) {
							$arrAUVals [] = $sqlfields [1];
						}
					}
					foreach ( $multivalues as $multiv ) {
						$arrAUVals [] = JText::_ ( $multiv->name );
					}
					$randMV = rand ( 0, 9999999 );
					$retorno .= '<script>CB(document).ready(function() {
			        var autoTmp=new obj_Autocompleter("' . $randMV . '"); ';
					foreach ( $arrAUVals as $auval ) {
						$retorno .= 'autoTmp.addVals("' . $auval . '");';
					}
					$retorno .= 'cb_autocompleter.add(autoTmp);';
					$retorno .= '});</script>';
					$retorno .= '<input type="text" data-provide="typeahead" placeholder="' . $field->placeholder . '" fldname="' . $field->var . '" ' . $class . ' name="fld_' . $field->id . $arr_suffix . '" au-list="' . $randMV . '" />';
				}
				break;
			case '11' :
				$session = JFactory::getSession ();
				$retorno .='
					<div id="filelist'.$field->id.'"></div><br />
					<input type="hidden" id="filelisthidden'.$field->id.'" ';
					    if ($field->mandatory == 1):
					    	$retorno .=' class="cb_requiredupload" ';
					    endif;					    
						$retorno .='/>
					<div id="container">
					    <a id="pickfile'.$field->id.'" class="btn btn-default" href="javascript:;">Select files</a>
					    <a id="uploadfiles'.$field->id.'" class="btn btn-primary" href="javascript:;">Upload files</a>
					</div>					 
					<br />					
					<script type="text/javascript">
					CB(document).ready(function() {	
						var uptmp = new plupload.Uploader({
							runtimes : "html5,flash,silverlight,html4",							
							browse_button:	"pickfile'. $field->id.'",						
					        // General settings
					        url : "'.JRoute::_('index.php?option=com_calcbuilder&controller=calcbuilder&task=upload&format=raw&id='.$field->id.'&idcalc=' . $utility ['id'].'&'.$session->getName ().'='.$session->getId () ).'",
					        unique_names : true,					         
					        filters : {
					            max_file_size : "'.$utility ["up_filesize"].'mb",
								';
							if($utility ["up_extensions"]!=''):
					           $retorno .=' mime_types: [
					                {title : "files", extensions : "'.$utility ["up_extensions"].'"},					                
					            ]';
							endif;
					       $retorno .=' },					 
					        // Resize images on clientside if we can
					        resize : {width : 320, height : 240, quality : 90},
							// Flash settings
        					flash_swf_url : "'.JRoute::_("modules/mod_calcbuilder/assets/js/Moxie.swf").'",
           					// Silverlight settings
        					silverlight_xap_url : "'.JRoute::_("modules/mod_calcbuilder/assets/js/Moxie.xap").'",
        					init: {        							
						        PostInit: function() {
						            document.getElementById("filelist'. $field->id.'").innerHTML = "";						 
						            document.getElementById("uploadfiles' . $field->id.'").onclick = function() {						            	
						                uploaders['.$field->id.'].start();
						                return false;
						            };
						        },
						 
						        FilesAdded: function(up, files) {
						            plupload.each(files, function(file) {
						                document.getElementById("filelist'. $field->id.'").innerHTML += \'<div id="\' + file.id + \'">\' + file.name + \' (\' + plupload.formatSize(file.size) + \') <b></b></div>\';
						            });
						            //up.start();
						        },
						 
						        UploadProgress: function(up, file) {
						            document.getElementById(file.id).getElementsByTagName("b")[0].innerHTML = "<span>" + file.percent + "%</span>";
						        },
						 
						        Error: function(up, err) {
						            //document.getElementById("console'. $field->id.'").innerHTML += "\nError #" + err.code + ": " + err.message;
						            console.error("Error #" + err.code + ": " + err.message);
						        },						            		
						        FileUploaded: function(elem, file, response) {
						            if (response.status=="200"){ // Uploaded OK
						            	CB("#filelisthidden'. $field->id.'").prop("filesuploaded",elem.files.length);	
									}
						        },
						    }
					    });        							
        				uptmp.init();
						uploaders['.$field->id.']=uptmp;						
					});        	
					</script>
				';
				
				/*
				$class .= ' "';
				$session = JFactory::getSession ();
				$retorno .= '<input type="hidden"  id="fld_' . $field->id . '" name="fld_' . $field->id . $arr_suffix . '"/>';
				$retorno .= '
		      	<script>		      	
		      	var swfu' . $seed . '_' . $field->id . '; 
				window.onload = function() {
				 
					var settings = 
					{
						button_window_mode: "transparent",	
					        //this is the path to the flash file, you need to put your components name into it
						flash_url : "' . JURI::base () . 'modules/mod_calcbuilder/assets/swfupload/swfupload.swf",
					        //we can not put any vars into the url for complicated reasons, but we can put them into the post...
					        upload_url: "index.php",
						post_params: 
						{
							"option" : "com_calcbuilder",
							"controller" : "calcbuilder",
							"task" : "upload",
							"id" : "' . $field->id . '",
							"idcalc" : "' . $utility ['id'] . '",
							"' . $session->getName () . '" : "' . $session->getId () . '",
							"format" : "raw"
						}, 
					    //you need to put the session and the "format raw" in there, the other ones are what you would normally put in the url
						file_size_limit : "' . $utility ["up_filesize"] . ' MB",
					    //client side file chacking is for usability only, you need to check server side for security
					    ';
				if ($utility ["up_extensions"] != null && $utility ["up_extensions"] != '') {
					$retorno .= 'file_types : "' . '*.' . str_replace ( ',', ';*.', $utility ["up_extensions"] ) . '",
					';
				}
				$retorno .= 'file_types_description : "All Files",
						file_upload_limit : ' . $utility ["up_maxuploadfiles"] . ',
						file_queue_limit : 100,
						custom_settings : 
						{
							progressTarget : "fsUploadProgress",
							cancelButtonId : "btnCancel"
						},
						debug: false,
						// Button settings
						//button_image_url: "' . JURI::base () . 'modules/mod_calcbuilder/assets/swfupload/TestImageNoText_65x29.png",
						button_width: "85",
						button_height: "29",
						button_placeholder_id: "spanButtonPlaceHolder",
						button_text: \'<span class="theFont">' . JText::_ ( 'CHOOSE_FILES' ) . '</span>\',
						button_text_style: ".theFont { font-family: Arial, Helvetica, _sans; }",
						button_text_left_padding: 5,
						button_text_top_padding: 5,						
						button_cursor:SWFUpload.CURSOR.HAND,
					 
						// The event handler functions are defined in handlers.js
						file_queued_handler : fileQueued,
						file_queue_error_handler : fileQueueError,
						file_dialog_complete_handler : fileDialogComplete,
						upload_start_handler : uploadStart,
						upload_progress_handler : uploadProgress,
						upload_error_handler : uploadError,
						upload_success_handler : uploadSuccess,
						upload_complete_handler : uploadComplete,
						queue_complete_handler : queueComplete	// Queue plugin event
					};
					swfu' . $seed . '_' . $field->id . ' = new SWFUpload(settings);
				};
				</script>';
				$retorno .= '<div class="fieldset flash" id="fsUploadProgress">
					<span class="legend">' . JText::_ ( "UPLOAD_QUEUE" ) . '</span>
				</div>
				<!--<div id="divStatus" class="divstatus">0 ' . JText::_ ( "FILES_UPLOADED" ) . '</div>-->
				<div>
					<span id="spanButtonPlaceHolder"></span>					
					<input id="btnCancel" type="button" style="cursor:pointer" value="' . JText::_ ( "CANCEL_ALL_UPLOADS" ) . '" onclick="swfu' . $seed . '_' . $field->id . '.cancelQueue();" disabled="disabled" style="margin-left: 2px; font-size: 0.9em; height: 29px;" /> 
				</div>';
				*/
				break;
			
			case '12' :
				$class .= ' "';
				$defval = $field->defaulttext;
				$iddefval = '';
				$retorno .= '<div class="radgroup">';
				$multivalues = $this->getMultivalueswrapper ( $field );
				if (count ( $multivalues ) > 0 || ($field->sqltext != null && trim ( $field->sqltext ) != '')) {
					if ($field->sqltext != null && trim ( $field->sqltext ) != '') {
						$more_fields = $this->getExecuteQuery ( $field->sqltext );
						$counter_multivalue = 0;
						foreach ( $more_fields as $sqlfields ) {
							$counter_multivalue ++;
							$retorno .= '<label class="radio">';
							$retorno .= '<input type="radio"  ' . $class . '  fldname="' . $field->var . '" mv_option="' . $sqlfields [0] . '" id="fld_' . $field->id . '_' . $counter_multivalue . '" 
		          					rad_name="fld_' . $field->id . $arr_suffix . '" name="rfld_' . $field->id . $arr_suffix . '" value="' . $sqlfields [0] . '"
		          					' . ($defval == $sqlfields [0] ? ' checked="checked" ' : '') . '
		          					/>';
							if ($defval == $sqlfields->mvkey)
								$iddefval = $sqlfields [0];
							$retorno .= JText::_ ( $sqlfields [1] );
							$retorno .= '</label>';
						}
					}
					/*
					 * $i=0; foreach ($multivalues as $multiv){
					 */
					for($i = 0; $i < count ( $multivalues ); $i ++) {
						$multiv = $multivalues [$i];
						// var_dump($multiv);
						$retorno .= '<label class="radio">';
						$retorno .= '<input type="radio" ' . $class . ' fldname="' . $field->var . '"   mv_option="' . $multiv->value . '" id="fld_' . $field->id . '_' . $i . '"  
		          				rad_name="fld_' . $field->id . $arr_suffix . '" name="rfld_' . $field->id . $arr_suffix . '" value="' . $multiv->id . '"
		          				' . ($defval == $multiv->value ? ' checked="checked" ' : '') . '
		          				/>';
						if ($defval == $multiv->value)
							$iddefval = $multiv->id;
						$retorno .= JText::_ ( $multiv->name );
						$retorno .= '</label>';
						// $i++;
					}
				}
				$retorno .= '<input type="hidden" name="fld_' . $field->id . $arr_suffix . '" value="' . $iddefval . '"/>';
				$retorno .= '</div>';
				// echo var_dump($multivalues);
				break;
			
			case '14' : // Inline
				$class .= ' cb_inline_calc"';
				$retorno .= '<div fldname="' . $field->var . '" name="fld_' . $field->id . $arr_suffix . '" 
		        			id="fld_' . $field->id . '" ' . $class . ' value="' . $field->defaulttext . '" ></div>';
				$retorno .= '<script>fieldsDataInline'.$seed.'.push("fld_' . $field->id . '");</script>';
				break;
				
			case '15' : // combo sql inline
					$class .= ' cb_sql_inline_calc"';
					$ref=rand ( 100000 , 999999 );
					$retorno .= '<select fldname="' . $field->var . '" name="fld_' . $field->id . $arr_suffix . '"					
		        			id="fld_' . $field->id . '" ' . $class . ' " data-ref="'.$ref.'"></select>';
					$trigger_arr_suffix=$this->_isFieldInSection($field->combodependantfield)?$arr_suffix:'';
					$retorno .= '<script>CB(document).ready(function() {
								setTimeout(function(){	
									CB("select[name=\'fld_' . $field->combodependantfield . $trigger_arr_suffix.  '\']").change(function(event,data){
										changeSqlInline(\''.JRoute::_('index.php').'\',\''.$seed.'calc_adminForm\', \'fld_' . $field->id . $arr_suffix . '\',\''.$field->id.'\',\''.$field->combodependantfield.'\',\''.$ref.'\');
									});
								},1000);		
							});</script>';
					break;
		}
		// $retorno.='</div></div>';
		?>
		    
		    <?php
		// Validacion de limit
		if ($field->limit0 != '' || $field->limit1 != '' || $field->type == 0) {
			/*
			 * $scriptDec='CB(document).ready(function() { CB.validator.addClassRules("elem'.$field->id.'", {"'; $first=true; if ($field->type==0){ if($first){$first=false;} else {$scriptDec.=',';} $scriptDec.='cb_number: ["'.$utility["thousand_number_format"].'","'.$utility["decimal_number_format"].'"]'; if($first){$first=false;} else {?>,<?php }?>cb_number_decimal: ["<?php echo $utility["thousand_number_format"]?>","<?php echo $utility["decimal_number_format"]?>","<?php echo $field->decimal;?>"] }
			 */
			?>
<script>
		      CB(document).ready(function() {		    	  
		    	  	CB.validator.addClassRules("elem<?php echo $field->id;?>", {
			    	  	<?php $first=true;?>
		    	  		<?php if ($field->type==0){ ?>
		    	  			<?php if($first){$first=false;} else {?>,<?php }?>cb_number: ["<?php echo $utility["thousand_number_format"]?>","<?php echo $utility["decimal_number_format"]?>"]
		    	  			<?php if($first){$first=false;} else {?>,<?php }?>cb_number_decimal: ["<?php echo $utility["thousand_number_format"]?>","<?php echo $utility["decimal_number_format"]?>","<?php echo $field->decimal;?>"]
		    	  		<?php } ?>
		    	  		<?php if (strlen($field->limit0) || strlen($field->limit1)){ ?>
		    	  			<?php if ($field->limit0!=''&&$field->limit1!=''){ ?>
		    	  				<?php if($first){$first=false;} else {?>,<?php }?>cb_between: ["<?php echo $field->limit0;?>","<?php echo $field->limit1;?>"]
		    	  			<?php } elseif ($field->limit0!=''){ ?>
		    	  				<?php if($first){$first=false;} else {?>,<?php }?>cb_greater: ["<?php echo $field->limit0;?>"]
		    	  			<?php } elseif ($field->limit1!=''){ ?>
	    	  					<?php if($first){$first=false;} else {?>,<?php }?>cb_smaller: ["<?php echo $field->limit1;?>"]
	    	  				<?php } ?>
		    	  		<?php } ?>
		    		});	
		      });
		      </script>
<?php
			// $document->addScriptDeclaration("");
		}
		
		return $retorno;
	}
	/**
	 *
	 * @param string $comString        	
	 * @param string $validationType:<br>
	 *        	100 => 1st char = validate db?<br>
	 *        	010 => 2nd char = validate backend folder?<br>
	 *        	001 => 3rd char = validate frontend folder?<br>
	 *        	111 => validate all example<br>
	 */
	public function validateComponent($comString, $validationType = 100) {
		jimport ( 'joomla.filesystem.folder' );
		// default result
		$validComponent = false;
		$validationsDone = 0;
		// use allways as string
		$validationType = ( string ) $validationType;
		// get required validations
		$validateDb = (isset ( $validationType [0] ) && $validationType [0] == '1');
		$validateBackend = (isset ( $validationType [1] ) && $validationType [1] == '1');
		$validateFrontend = (isset ( $validationType [2] ) && $validationType [2] == '1');
		// validate: extension is present and enabled on db
		if (($validationsDone == 0 || ($validComponent)) && $validateDb) {
			$db = JFactory::getDbo ();
			$query = $db->getQuery ( true );
			$query->select ( 'extension_id, name' );
			$query->from ( '#__extensions' );
			$query->where ( 'name=' . $db->quote ( $comString ) );
			$db->setQuery ( $query );
			if ($db->loadObject ()) {
				$validComponent = true;
			} else {
				$validComponent = false;
			}
			$validationsDone ++;
		}
		// validate: backend folder exist
		if (($validationsDone == 0 || ($validComponent)) && $validateBackend) {
			$backendPath = JPATH_ADMINISTRATOR . DS . 'components' . DS . $comString;
			$validComponent = JFolder::exists ( $backendPath );
			$validationsDone ++;
		}
		// validate: frontend folder exist
		if (($validationsDone == 0 || ($validComponent)) && $validateFrontend) {
			$frontendPath = JPATH_SITE . DS . 'components' . DS . $comString;
			$validComponent = JFolder::exists ( $frontendPath );
			$validationsDone ++;
		}
		return $validComponent;
	}
}
?>
